using System;
using System.Text;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
namespace ConsoleApplicationPhoneBook
{
    /**
     *     
     *
     * @author   ,   ,  , 
     * @version 2/8/2007
     */
    class PhoneBook
    {
        private List<Contact> phoneBook;
        private int numOfContacts;

        public PhoneBook()
        {
            this.phoneBook = new List<Contact>();
            this.numOfContacts = 0;
        }

        public void AddContact(String name, String phone)
        {
            Node<Contact> prev = null;
            Node<Contact> pos = this.phoneBook.GetFirst();

            while (pos != null && name.CompareTo(pos.GetInfo().GetName()) > 0)
            {
                prev = pos;
                pos = pos.GetNext();
            }

            this.phoneBook.Insert(prev, new Contact(name, phone));
            this.numOfContacts++;
        }

        public void DelContact(String name)
        {
            Node<Contact> pos = this.phoneBook.GetFirst();

            while (name.CompareTo(pos.GetInfo().GetName()) != 0)
                pos = pos.GetNext();

            this.phoneBook.Remove(pos);
            this.numOfContacts--;
        }

        public String GetPhone(String name)
        {
            Node<Contact> pos = this.phoneBook.GetFirst();

            while (pos != null)
            {
                if (pos.GetInfo().GetName().Equals(name))
                    return (pos.GetInfo().GetPhone());
                pos = pos.GetNext();
            }

            return (null);
        }

        public void SetPhone(String name, String phone)
        {
            Node<Contact> pos = this.phoneBook.GetFirst();

            while (name.CompareTo(pos.GetInfo().GetName()) != 0)
                pos = pos.GetNext();

            pos.GetInfo().SetPhone(phone);
        }

        public String[] GetAllContactsNames()
        {
            String[] names = new String[this.numOfContacts];
            Node<Contact> pos = this.phoneBook.GetFirst();

            for (int i = 0; i < this.numOfContacts; i++)
            {
                names[i] = pos.GetInfo().GetName();
                pos = pos.GetNext();
            }

            return (names);
        }


        public override String ToString()
        {
            String str = "";
            Node<Contact> pos = this.phoneBook.GetFirst();

            while (pos != null)
            {
                //str = str + String.Format("%-20s %10s\n", pos.GetInfo().GetName(), pos.GetInfo().GetPhone());
                str = str + String.Format("{0}\t {1}\n", pos.GetInfo().GetName(), pos.GetInfo().GetPhone());
                pos = pos.GetNext();
            }

            return (str);
        }
    }
}
